struct FP {
  struct FP *next;
  struct FP *prev;
  int       points;
  double    *point;
  float     color[3];
};

struct CP {
  struct CP *next;
  struct CP *prev;
  int       points;
  double    *point;
  float     color[3];
};

struct DH {
  struct DH *next;
  struct DH *prev;
  double    alpha;
  double    theta;
  double    a;
  double    d;
  int 	    parent;
  int       faces;
  struct FP *face;
  struct CP *calc;
  float     color[3];
};

struct files {
  struct files *next;
  struct files *prev;
  int          number;
  char         name[256];
};

struct dynamic {
  struct      dynamic *next;
  struct      dynamic *prev;
  int         number;
  int         link;
  /*
  link -> -1: unuse
  */
  int         param;
  /*
  param -> 0:alpha 1:theta 2:a 3:d
  */
};

struct agent {
  struct agent   *next;
  struct DH      start;
  struct dynamic dstart;
  struct files   lstart;
  int            links, dynamics;
  int            xc, yc, zc;
  int            use0link;
};

struct report {
    struct report *prev;
    struct report *next;
    int	   degree;
    int    type;
    int    flag;
};
